import { IOptions, ICoreInstance, ICommands, IHooks } from './interface/commandHookCore';
import { IPluginInstance } from './interface/plugin';
import { IProviderInstance } from './interface/provider';
declare const _default: {
    new (options: IOptions): {
        options: IOptions;
        instances: IPluginInstance[];
        commands: ICommands;
        hooks: IHooks;
        coreInstance: ICoreInstance;
        providers: any;
        npmPlugin: string[];
        loadNpm: any;
        addPlugin(Plugin: any): void;
        invoke(commandsArray?: string[], allowEntryPoints?: boolean, options?: any): Promise<void>;
        spawn(commandsArray: string | string[], options?: any): Promise<void>;
        getCommands(): ICommands;
        ready(): Promise<void>;
        getCoreInstance(): ICoreInstance;
        setProvider(providerName: string, providerInstance: IProviderInstance): void;
        getProvider(providerName: string): IProviderInstance;
        loadCommands(instance: any, commandsMap: any, commands: any, parentCommandList?: string[]): void;
        loadHooks(hooks: any): void;
        loadLifecycle(command: string, lifecycleEvents: string[], parentCommandList?: string[]): string[];
        getCommand(commandsArray: string[], allowEntryPoints?: boolean): any;
        loadLocalPlugin(localPath: any): Promise<void>;
        loadNpmPlugins(): Promise<void>;
        asyncInit(): Promise<void>;
        commandOptions(commandOptions: any): any;
        displayHelp(commandsArray: any, usage: any): void;
        error<T>(type: string, info?: T): void;
    };
};
export = _default;
