import { IProviderInstance } from './provider';
import { ICommandInstance } from './plugin';
export interface ILog {
    log: (...any: any[]) => void;
    error?: (...any: any[]) => void;
}
export interface IOptions {
    provider: string;
    options?: any;
    commands?: string[];
    service?: any;
    config?: any;
    log?: ILog;
    extensions?: {
        [extensionName: string]: any;
    };
    displayUsage?: any;
    point?: any;
    npm?: string;
}
export interface ICommandHooksCore {
    addPlugin(plugin: IPlugin): void;
}
export interface ICoreInstance {
    classes: any;
    cli: ILog | Console;
    config: any;
    getProvider(providerName: string): IProviderInstance;
    invoke(commandsArray?: string[], allowEntryPoints?: boolean, options?: any): any;
    pluginManager: ICommandHooksCore;
    service: {
        provider: {
            name: string;
        };
    };
    processedInput: {
        options: any;
        commands: string[];
    };
    setProvider(providerName: string, providerInstance: IProviderInstance): any;
    spawn(commandsArray: string[], options?: any): any;
}
export declare class IPlugin {
    constructor(coreInstance: ICoreInstance, options: any);
}
export interface ICommands {
    [command: string]: {
        usage: string;
        type: string;
        lifecycleEvents: string[];
        rank: number;
        options: {};
        origin: ICommandInstance[];
        commands: ICommands;
    };
}
export declare type IHookFun = () => Promise<void> | void;
export interface IHooks {
    [lifestyle: string]: IHookFun[];
}
